`include "ComputeSignal.v"

module top;

  reg reset;

  reg clk = 1'b1;
  always begin
    #5;
    clk = ~clk;
  end

  reg [31:0] cycle_num = 32'b0;
  always @ ( posedge clk ) begin
    cycle_num = cycle_num + 1'b1;
  end

  // DUT instantiation

  wire compute;

  ComputeSignal compute_signal
  (
   .clk     (clk),
   .reset   (reset),
   .count_max (5),
   .compute (compute)
  );

  initial begin
    $dumpfile("tapper.vcd");
    $dumpvars(0, top);

    #1; reset = 1'b1;
    #10; reset = 1'b0;

    #2000;

    #3000;

    $finish;
  end

endmodule
