`include "vc-Counter.v"

module ComputeSignal
(
 input       clk,
 input       reset,

 input [7:0] count_max,
 output reg  compute
);

  wire      count_is_max = count == count_max;

  wire [7:0] count;

  vc_Counter
  #(
    .p_count_nbits       (8),
    .p_count_reset_value (8'd0),
    .p_count_max_value   (8'd255)
  )
  counter
  (
   .clk           (clk),
   .reset         (reset || count_is_max),
   .increment     (1'b1),
   .decrement     (1'b0),
   .count         (count),
   .count_is_zero (),
   .count_is_max  ()
  );

  always @ ( posedge clk ) begin
    if ( reset ) begin
      compute <= 1'b0;
    end else begin
      if ( count_is_max ) begin
        compute <= ~compute;
      end
    end
  end

endmodule
