`ifndef DATA_STORE_V
`define DATA_STORE_V

module DataStore
#(
  parameter p_nbits = 8
)(
  input                    clk,
  input                    reset,

  input                    en,
  input                    clear,

  input                    valid_in,
  input [p_nbits-1:0]      data_in,

  output reg               valid,
  output reg [p_nbits-1:0] data
);

  always @ ( posedge clk ) begin

    if ( reset || clear ) begin

      valid <= 1'b0;
      data  <= {p_nbits{1'b0}};

    end else begin

      if ( valid_in && en ) begin

        valid <= valid_in;
        data  <= data_in;

      end

    end

  end

endmodule

`endif
