`ifndef READ_SWITCH_V
`define READ_SWITCH_V

module ReadSwitch
(
 input [7:0]       data,
 output reg [16:0] addr,

 output reg        pause_c,
 output reg [7:0]  data_c,
 input [16:0]      addr_c,

 input             demand_0,
 output reg [7:0]  data_0,
 input [16:0]      addr_0,

 input             demand_1,
 output reg [7:0]  data_1,
 input [16:0]      addr_1,

 input             demand_2,
 output reg [7:0]  data_2,
 input [16:0]      addr_2
);

  // Fixed priority arbitration, based on input number
  // The greater the number, the higher the priority
  always @ ( * ) begin
    if ( demand_2 ) begin
      pause_c <= 1'b1;
      data_c <= 8'b0;
      data_0 <= 8'b0;
      data_1 <= 8'b0;
      data_2 <= data;
      addr <= addr_2;
    end else if ( demand_1 ) begin
      pause_c <= 1'b1;
      data_c <= 8'b0;
      data_0 <= 8'b0;
      data_1 <= data;
      data_2 <= 8'b0;
      addr <= addr_1;
    end else if ( demand_0 ) begin
      pause_c <= 1'b1;
      data_c <= 8'b0;
      data_0 <= data;
      data_1 <= 8'b0;
      data_2 <= 8'b0;
      addr <= addr_0;
    end else begin
      pause_c <= 1'b0;
      data_c <= data;
      data_0 <= 8'b0;
      data_1 <= 8'b0;
      data_2 <= 8'b0;
      addr <= addr_c;
    end
  end

endmodule

`endif
