`include "ThinkControl.v"

module top;

  reg reset;

  reg clk = 1'b1;
  always begin
    #5;
    clk = ~clk;
  end

  reg [31:0] cycle_num = 32'b0;
  always @ ( posedge clk ) begin
    cycle_num = cycle_num + 1'b1;
  end

  // DUT instantiation

  wire compute_go;
  wire reset_compute_and_tapper;
  reg  tapper_done;

  ThinkControl think_control
  (
   .clk                      (clk),
   .reset                    (reset),
   .cycles_between_compute   (50),
   .tapper_done              (tapper_done),
   .compute_go               (compute_go),
   .reset_compute_and_tapper (reset_compute_and_tapper)
  );

  initial begin
    $dumpfile("ThinkControl.vcd");
    $dumpvars(0, top);

    #1; reset = 1'b1;
    #10; reset = 1'b0;

    tapper_done = 1'b0;

    #200;

    tapper_done = 1'b1;
    #10;
    tapper_done = 1'b0;

    #2000;

    $finish;
  end

endmodule
