//=========================================================================
// Verilog Components: T-Flip-Flop
//=========================================================================

`ifndef VC_TFLIPFLOP_V
`define VC_TFLIPFLOP_V

module vc_TFlipFlop
#(
  parameter reset_value = 1'b0
)(
  input  clk,
  input  reset,

  input  t,
  output q
);

  //----------------------------------------------------------------------
  // Internal state
  //----------------------------------------------------------------------

  reg    state;
  wire   state_next;

  always @ ( posedge clk ) begin
    if ( reset ) begin
      state <= reset_value;
    end else begin
      if ( t ) begin
        state <= state_next;
      end else begin
        state <= state;
      end
    end
  end

  //----------------------------------------------------------------------
  // Combinational Logic
  //----------------------------------------------------------------------

  assign state_next = ~state;

  //----------------------------------------------------------------------
  // Assign outputs
  //----------------------------------------------------------------------

  assign q = state;

endmodule

`endif
